明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1760|回复: 3

请教高手图形坐标转换的问题

[复制链接]
发表于 2008-5-19 17:24:00 | 显示全部楼层 |阅读模式
我想做个图形坐标转换的程序(vba),想提取图形中的所有的点坐标,然后用新坐标替换,那为高手能指教一下,遍历图形中的每一个点,怎么遍历?我所说的点包括线状地物上的拐点等等
 楼主| 发表于 2008-5-20 11:17:00 | 显示全部楼层

怎么没人回答呢?

发表于 2008-7-6 12:51:00 | 显示全部楼层

我也在搞坐标转换的问题,多多交流qq375564896

发表于 2008-7-19 20:43:00 | 显示全部楼层

现要知道转换参数才行的。我用lisp弄了一个很简单的

(defun c:zh();将54系转换为苏州独立坐标系

  ;(startapp  "e:/zbzh.exe")
  ;(command "delay" 10000);延迟时间
  ;(setq cswj "e:/cswj.txt")    
  ;(setq fp3 (open cswj "r"))
  ;(setq jd (atof (read-line fp3)))
  ;(setq x0 (atof (read-line fp3)))
  ;(setq y0 (atof (read-line fp3)))
  ;(close fp3)
  (setq jd 旋转角度)
  (setq jd (* jd 0.017453292))
  (setq y0 Y方向平移)
  (setq x0 X方向平移)
  (setq cs (cos  jd ))
  (setq si (sin  jd ))
  (setq kkk 0.999973920009)
  (setq a1 (ssget "X"))
  (setq shumu (sslength a1))
  (setq j 0)
  (setq tj 0)
  (repeat shumu
    (setq a2 (ssname a1 j))
    (setq a (entget a2))
    (setq n (length a ))
    (setq kk 0)
    (repeat n
    (setq m (nth kk a))
    (if (= (car m) 10) 
     (progn
      (setq tj (+ tj 1))
      (setq p1 (cdr m))
      (setq y11 (car p1))
      (setq x11 (cadr p1))
      ;(setq x1 (- (+ x0 (* k ( * x11  cs))) (* y11  si)))
      ;(setq y1 (+ (+ y0 ( * x11  si)) (* y11  cs)))
     
      (setq x1 (- (+ x0 (* kkk (* x11  cs))) (* kkk (* y11  si))))
      (setq y1 (+ (+ y0 (* kkk (* x11  si))) (* kkk (* y11  cs))))
      (setq p1 (list  y1 x1))
      (setq b1 (nth kk a))
      (setq b2 (cons 10 p1))
      (setq a (subst b2 b1 a))
      (entmod a)
      )
     )
     (if (= (car m) 11)
 (progn
    (setq tj (+ tj 1))
           (setq p1 (cdr m))
    (setq y11 (car p1))
           (setq x11 (cadr p1))
           (setq x1 (- (+ x0 (* kkk( * x11  cs))) (* kkk (* y11  si))))
           (setq y1 (+ (+ y0 (* kkk( * x11  si))) (* kkk (* y11  cs))))
           (setq p1 (list  y1 x1))

           (setq b1 (nth kk a))
           (setq b2 (cons 11 p1))
           (setq a (subst b2 b1 a))
           (entmod a)
  )
      )
      (setq kk (+ kk 1))
    )
    ;一个实体计算完毕,开始下一个循环。
    (setq j (+ j 1))
    )
  (princ)
  )

您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-26 06:30 , Processed in 0.180287 second(s), 23 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表